Fix execution group of NodeD
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         doc/users \
104         test/data/htools \
105         test/data/htools/rapi \
106         test/hs/shelltests \
107         test/autotools \
108         lib \
109         lib/build \
110         lib/client \
111         lib/cmdlib \
112         lib/confd \
113         lib/http \
114         lib/hypervisor \
115         lib/impexpd \
116         lib/masterd \
117         lib/rapi \
118         lib/server \
119         lib/tools \
120         lib/utils \
121         lib/watcher \
122         man \
123         qa \
124         test \
125         test/data \
126         test/data/bdev-rbd \
127         test/data/ovfdata \
128         test/data/ovfdata/other \
129         test/py \
130         tools
131
132 ALL_APIDOC_HS_DIRS = \
133         $(APIDOC_HS_DIR) \
134         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
135
136 BUILDTIME_DIR_AUTOCREATE = \
137         scripts \
138         $(APIDOC_DIR) \
139         $(ALL_APIDOC_HS_DIRS) \
140         $(APIDOC_PY_DIR) \
141         $(COVERAGE_DIR) \
142         $(COVERAGE_HS_DIR) \
143         $(COVERAGE_PY_DIR) \
144         .hpc
145
146 BUILDTIME_DIRS = \
147         $(BUILDTIME_DIR_AUTOCREATE) \
148         doc/html \
149         doc/man-html
150
151 DIRCHECK_EXCLUDE = \
152         $(BUILDTIME_DIRS) \
153         ganeti-[0-9]*.[0-9]*.[0-9]* \
154         doc/html/_* \
155         doc/man-html/_* \
156         autom4te.cache
157
158 # some helper vars
159 COVERAGE_DIR = doc/coverage
160 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
161 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
162 APIDOC_DIR = doc/api
163 APIDOC_PY_DIR = $(APIDOC_DIR)/py
164 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
165
166 MAINTAINERCLEANFILES = \
167         $(maninput) \
168         doc/install-quick.rst \
169         doc/news.rst \
170         doc/upgrade.rst \
171         vcs-version
172
173 maintainer-clean-local:
174         rm -rf $(BUILDTIME_DIRS)
175
176 CLEANFILES = \
177         $(addsuffix /*.py[co],$(DIRS)) \
178         $(addsuffix /*.hi,$(HS_DIRS)) \
179         $(addsuffix /*.o,$(HS_DIRS)) \
180         $(PYTHON_BOOTSTRAP) \
181         epydoc.conf \
182         $(REPLACE_VARS_SED) \
183         $(SHELL_ENV_INIT) \
184         daemons/daemon-util \
185         daemons/ganeti-cleaner \
186         devel/squeeze-amd64.tar.gz \
187         devel/squeeze-amd64.conf \
188         $(mandocrst) \
189         doc/manpages-enabled.rst \
190         $(BUILT_EXAMPLES) \
191         doc/examples/bash_completion \
192         doc/examples/bash_completion-debug \
193         $(userspecs) \
194         lib/_generated_rpc.py \
195         $(man_MANS) \
196         $(manhtml) \
197         tools/kvm-ifup \
198         tools/users-setup \
199         tools/vcluster-setup \
200         stamp-directories \
201         stamp-srclinks \
202         $(nodist_pkgpython_PYTHON) \
203         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
204         $(HS_BUILT_TEST_HELPERS) \
205         src/ganeti-confd \
206         src/ganeti-luxid \
207         src/ganeti-mond \
208         .hpc/*.mix src/*.tix test/hs/*.tix \
209         doc/hs-lint.html
210
211 GENERATED_FILES = \
212         $(built_base_sources) \
213         $(BUILT_PYTHON_SOURCES) \
214         $(PYTHON_BOOTSTRAP)
215
216 HS_GENERATED_FILES =
217 if WANT_HTOOLS
218 HS_GENERATED_FILES += $(HS_PROGS)
219 if ENABLE_CONFD
220 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
221 endif
222
223 if ENABLE_MOND
224 HS_GENERATED_FILES += src/ganeti-mond
225 endif
226 endif
227
228 built_base_sources = \
229         stamp-directories \
230         stamp-srclinks
231
232 built_python_base_sources = \
233         lib/_autoconf.py \
234         lib/_vcsversion.py
235
236 BUILT_PYTHON_SOURCES = \
237         $(built_python_base_sources) \
238         lib/_generated_rpc.py
239
240 # Generating the RPC wrappers depends on many things, so make sure
241 # it's built at the end of the built sources
242 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
243
244 # these are all built from the underlying %.in sources
245 BUILT_EXAMPLES = \
246         doc/examples/ganeti-kvm-poweroff.initd \
247         doc/examples/ganeti.cron \
248         doc/examples/ganeti.initd \
249         doc/examples/ganeti.logrotate \
250         doc/examples/ganeti-master-role.ocf \
251         doc/examples/ganeti-node-role.ocf \
252         doc/examples/gnt-config-backup \
253         doc/examples/hooks/ipsec
254
255 nodist_pkgpython_PYTHON = \
256         $(BUILT_PYTHON_SOURCES)
257
258 noinst_PYTHON = \
259         lib/build/__init__.py \
260         lib/build/shell_example_lexer.py \
261         lib/build/sphinx_ext.py
262
263 pkgpython_PYTHON = \
264         lib/__init__.py \
265         lib/asyncnotifier.py \
266         lib/backend.py \
267         lib/bdev.py \
268         lib/bootstrap.py \
269         lib/cli.py \
270         lib/compat.py \
271         lib/config.py \
272         lib/constants.py \
273         lib/daemon.py \
274         lib/errors.py \
275         lib/hooksmaster.py \
276         lib/ht.py \
277         lib/jqueue.py \
278         lib/jstore.py \
279         lib/locking.py \
280         lib/luxi.py \
281         lib/mcpu.py \
282         lib/netutils.py \
283         lib/objects.py \
284         lib/opcodes.py \
285         lib/outils.py \
286         lib/ovf.py \
287         lib/pathutils.py \
288         lib/qlang.py \
289         lib/query.py \
290         lib/rpc.py \
291         lib/rpc_defs.py \
292         lib/runtime.py \
293         lib/serializer.py \
294         lib/ssconf.py \
295         lib/ssh.py \
296         lib/storage.py \
297         lib/uidpool.py \
298         lib/vcluster.py \
299         lib/network.py \
300         lib/workerpool.py
301
302 client_PYTHON = \
303         lib/client/__init__.py \
304         lib/client/gnt_backup.py \
305         lib/client/gnt_cluster.py \
306         lib/client/gnt_debug.py \
307         lib/client/gnt_group.py \
308         lib/client/gnt_instance.py \
309         lib/client/gnt_job.py \
310         lib/client/gnt_node.py \
311         lib/client/gnt_network.py \
312         lib/client/gnt_os.py \
313         lib/client/gnt_storage.py
314
315 cmdlib_PYTHON = \
316         lib/cmdlib/__init__.py \
317         lib/cmdlib/backup.py \
318         lib/cmdlib/base.py \
319         lib/cmdlib/cluster.py \
320         lib/cmdlib/common.py \
321         lib/cmdlib/group.py \
322         lib/cmdlib/instance.py \
323         lib/cmdlib/instance_migration.py \
324         lib/cmdlib/instance_operation.py \
325         lib/cmdlib/instance_query.py \
326         lib/cmdlib/instance_storage.py \
327         lib/cmdlib/instance_utils.py \
328         lib/cmdlib/misc.py \
329         lib/cmdlib/network.py \
330         lib/cmdlib/node.py \
331         lib/cmdlib/operating_system.py \
332         lib/cmdlib/query.py \
333         lib/cmdlib/tags.py \
334         lib/cmdlib/test.py
335
336 hypervisor_PYTHON = \
337         lib/hypervisor/__init__.py \
338         lib/hypervisor/hv_base.py \
339         lib/hypervisor/hv_chroot.py \
340         lib/hypervisor/hv_fake.py \
341         lib/hypervisor/hv_kvm.py \
342         lib/hypervisor/hv_lxc.py \
343         lib/hypervisor/hv_xen.py
344
345 rapi_PYTHON = \
346         lib/rapi/__init__.py \
347         lib/rapi/baserlib.py \
348         lib/rapi/client.py \
349         lib/rapi/client_utils.py \
350         lib/rapi/connector.py \
351         lib/rapi/rlib2.py \
352         lib/rapi/testutils.py
353
354 http_PYTHON = \
355         lib/http/__init__.py \
356         lib/http/auth.py \
357         lib/http/client.py \
358         lib/http/server.py
359
360 confd_PYTHON = \
361         lib/confd/__init__.py \
362         lib/confd/client.py
363
364 masterd_PYTHON = \
365         lib/masterd/__init__.py \
366         lib/masterd/iallocator.py \
367         lib/masterd/instance.py
368
369 impexpd_PYTHON = \
370         lib/impexpd/__init__.py
371
372 watcher_PYTHON = \
373         lib/watcher/__init__.py \
374         lib/watcher/nodemaint.py \
375         lib/watcher/state.py
376
377 server_PYTHON = \
378         lib/server/__init__.py \
379         lib/server/masterd.py \
380         lib/server/noded.py \
381         lib/server/rapi.py
382
383 pytools_PYTHON = \
384         lib/tools/__init__.py \
385         lib/tools/burnin.py \
386         lib/tools/ensure_dirs.py \
387         lib/tools/node_cleanup.py \
388         lib/tools/node_daemon_setup.py \
389         lib/tools/prepare_node_join.py
390
391 utils_PYTHON = \
392         lib/utils/__init__.py \
393         lib/utils/algo.py \
394         lib/utils/filelock.py \
395         lib/utils/hash.py \
396         lib/utils/io.py \
397         lib/utils/log.py \
398         lib/utils/lvm.py \
399         lib/utils/mlock.py \
400         lib/utils/nodesetup.py \
401         lib/utils/process.py \
402         lib/utils/retry.py \
403         lib/utils/text.py \
404         lib/utils/wrapper.py \
405         lib/utils/x509.py
406
407 docinput = \
408         doc/conf.py \
409         doc/css/style.css \
410         doc/admin.rst \
411         doc/cluster-merge.rst \
412         doc/design-2.0.rst \
413         doc/design-2.1.rst \
414         doc/design-2.2.rst \
415         doc/design-2.3.rst \
416         doc/design-2.4.rst \
417         doc/design-2.5.rst \
418         doc/design-2.6.rst \
419         doc/design-2.7.rst \
420         doc/design-2.8.rst \
421         doc/design-autorepair.rst \
422         doc/design-bulk-create.rst \
423         doc/design-chained-jobs.rst \
424         doc/design-cpu-pinning.rst \
425         doc/design-device-uuid-name.rst \
426         doc/design-draft.rst \
427         doc/design-daemons.rst \
428         doc/design-htools-2.3.rst \
429         doc/design-http-server.rst \
430         doc/design-impexp2.rst \
431         doc/design-lu-generated-jobs.rst \
432         doc/design-linuxha.rst \
433         doc/design-multi-reloc.rst \
434         doc/design-network.rst \
435         doc/design-node-add.rst \
436         doc/design-oob.rst \
437         doc/design-ovf-support.rst \
438         doc/design-opportunistic-locking.rst \
439         doc/design-partitioned.rst \
440         doc/design-query-splitting.rst \
441         doc/design-query2.rst \
442         doc/design-reason-trail.rst \
443         doc/design-resource-model.rst \
444         doc/design-restricted-commands.rst \
445         doc/design-shared-storage.rst \
446         doc/design-monitoring-agent.rst \
447         doc/design-virtual-clusters.rst \
448         doc/design-x509-ca.rst \
449         doc/design-hroller.rst \
450         doc/design-storagetypes.rst \
451         doc/devnotes.rst \
452         doc/glossary.rst \
453         doc/hooks.rst \
454         doc/iallocator.rst \
455         doc/index.rst \
456         doc/install-quick.rst \
457         doc/install.rst \
458         doc/locking.rst \
459         doc/manpages-disabled.rst \
460         doc/monitoring-query-format.rst \
461         doc/move-instance.rst \
462         doc/news.rst \
463         doc/ovfconverter.rst \
464         doc/rapi.rst \
465         doc/security.rst \
466         doc/upgrade.rst \
467         doc/virtual-cluster.rst \
468         doc/walkthrough.rst
469
470 # Generates file names such as "doc/man-gnt-instance.rst"
471 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
472
473 # Haskell programs to be installed in $PREFIX/bin
474 HS_BIN_PROGS=src/htools
475
476 # Haskell programs to be installed in the MYEXECLIB dir
477 if ENABLE_MOND
478 HS_MYEXECLIB_PROGS=src/mon-collector
479 else
480 HS_MYEXECLIB_PROGS=
481 endif
482
483 # Haskell programs to be compiled by "make really-all"
484 HS_COMPILE_PROGS= \
485         src/ganeti-mond \
486         src/hconfd \
487         src/hluxid \
488         src/rpc-test
489
490 # All Haskell non-test programs to be compiled but not automatically installed
491 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
492
493 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
494 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
495
496 HS_ALL_PROGS = \
497         $(HS_PROGS) \
498         test/hs/hpc-htools \
499         test/hs/hpc-mon-collector \
500         test/hs/htest \
501         $(HS_COMPILE_PROGS)
502
503 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
504 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
505
506 HFLAGS = \
507         -O -Wall -Werror -isrc \
508         -fwarn-monomorphism-restriction \
509         -fwarn-tabs \
510         $(GHC_BYVERSION_FLAGS)
511
512 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
513 HEXTRA =
514 # internal extra flags (used for test/hs/htest mainly)
515 HEXTRA_INT =
516 # exclude options for coverage reports
517 HPCEXCL = --exclude Main \
518         --exclude Ganeti.Constants \
519         --exclude Ganeti.HTools.QC \
520         --exclude Ganeti.THH \
521         --exclude Ganeti.Version \
522         --exclude Test.Ganeti.Attoparsec \
523         --exclude Test.Ganeti.TestCommon \
524         --exclude Test.Ganeti.TestHTools \
525         --exclude Test.Ganeti.TestHelper \
526         --exclude Test.Ganeti.TestImports \
527         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
528
529 HS_LIB_SRCS = \
530         src/Ganeti/Block/Drbd/Types.hs \
531         src/Ganeti/Block/Drbd/Parser.hs \
532         src/Ganeti/BasicTypes.hs \
533         src/Ganeti/Common.hs \
534         src/Ganeti/Compat.hs \
535         src/Ganeti/Confd/Client.hs \
536         src/Ganeti/Confd/Server.hs \
537         src/Ganeti/Confd/Types.hs \
538         src/Ganeti/Confd/Utils.hs \
539         src/Ganeti/Config.hs \
540         src/Ganeti/ConfigReader.hs \
541         src/Ganeti/Curl/Multi.hs \
542         src/Ganeti/Daemon.hs \
543         src/Ganeti/DataCollectors/CLI.hs \
544         src/Ganeti/DataCollectors/Drbd.hs \
545         src/Ganeti/DataCollectors/Program.hs \
546         src/Ganeti/DataCollectors/Types.hs \
547         src/Ganeti/Errors.hs \
548         src/Ganeti/HTools/Backend/IAlloc.hs \
549         src/Ganeti/HTools/Backend/Luxi.hs \
550         src/Ganeti/HTools/Backend/Rapi.hs \
551         src/Ganeti/HTools/Backend/Simu.hs \
552         src/Ganeti/HTools/Backend/Text.hs \
553         src/Ganeti/HTools/CLI.hs \
554         src/Ganeti/HTools/Cluster.hs \
555         src/Ganeti/HTools/Container.hs \
556         src/Ganeti/HTools/ExtLoader.hs \
557         src/Ganeti/HTools/Graph.hs \
558         src/Ganeti/HTools/Group.hs \
559         src/Ganeti/HTools/Instance.hs \
560         src/Ganeti/HTools/Loader.hs \
561         src/Ganeti/HTools/Nic.hs \
562         src/Ganeti/HTools/Node.hs \
563         src/Ganeti/HTools/PeerMap.hs \
564         src/Ganeti/HTools/Program/Hail.hs \
565         src/Ganeti/HTools/Program/Harep.hs \
566         src/Ganeti/HTools/Program/Hbal.hs \
567         src/Ganeti/HTools/Program/Hcheck.hs \
568         src/Ganeti/HTools/Program/Hinfo.hs \
569         src/Ganeti/HTools/Program/Hscan.hs \
570         src/Ganeti/HTools/Program/Hspace.hs \
571         src/Ganeti/HTools/Program/Hroller.hs \
572         src/Ganeti/HTools/Program/Main.hs \
573         src/Ganeti/HTools/Types.hs \
574         src/Ganeti/Hypervisor/Xen/XmParser.hs \
575         src/Ganeti/Hypervisor/Xen/Types.hs \
576         src/Ganeti/Hash.hs \
577         src/Ganeti/JQueue.hs \
578         src/Ganeti/JSON.hs \
579         src/Ganeti/Jobs.hs \
580         src/Ganeti/Logging.hs \
581         src/Ganeti/Luxi.hs \
582         src/Ganeti/Monitoring/Server.hs \
583         src/Ganeti/Network.hs \
584         src/Ganeti/Objects.hs \
585         src/Ganeti/OpCodes.hs \
586         src/Ganeti/OpParams.hs \
587         src/Ganeti/Path.hs \
588         src/Ganeti/Query/Common.hs \
589         src/Ganeti/Query/Export.hs \
590         src/Ganeti/Query/Filter.hs \
591         src/Ganeti/Query/Group.hs \
592         src/Ganeti/Query/Job.hs \
593         src/Ganeti/Query/Language.hs \
594         src/Ganeti/Query/Network.hs \
595         src/Ganeti/Query/Node.hs \
596         src/Ganeti/Query/Query.hs \
597         src/Ganeti/Query/Server.hs \
598         src/Ganeti/Query/Types.hs \
599         src/Ganeti/Rpc.hs \
600         src/Ganeti/Runtime.hs \
601         src/Ganeti/Ssconf.hs \
602         src/Ganeti/THH.hs \
603         src/Ganeti/Types.hs \
604         src/Ganeti/Utils.hs
605
606 HS_TEST_SRCS = \
607         test/hs/Test/Ganeti/Attoparsec.hs \
608         test/hs/Test/Ganeti/BasicTypes.hs \
609         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
610         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
611         test/hs/Test/Ganeti/Common.hs \
612         test/hs/Test/Ganeti/Confd/Types.hs \
613         test/hs/Test/Ganeti/Confd/Utils.hs \
614         test/hs/Test/Ganeti/Daemon.hs \
615         test/hs/Test/Ganeti/Errors.hs \
616         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
617         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
618         test/hs/Test/Ganeti/HTools/CLI.hs \
619         test/hs/Test/Ganeti/HTools/Cluster.hs \
620         test/hs/Test/Ganeti/HTools/Container.hs \
621         test/hs/Test/Ganeti/HTools/Graph.hs \
622         test/hs/Test/Ganeti/HTools/Instance.hs \
623         test/hs/Test/Ganeti/HTools/Loader.hs \
624         test/hs/Test/Ganeti/HTools/Node.hs \
625         test/hs/Test/Ganeti/HTools/PeerMap.hs \
626         test/hs/Test/Ganeti/HTools/Types.hs \
627         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
628         test/hs/Test/Ganeti/JSON.hs \
629         test/hs/Test/Ganeti/Jobs.hs \
630         test/hs/Test/Ganeti/JQueue.hs \
631         test/hs/Test/Ganeti/Luxi.hs \
632         test/hs/Test/Ganeti/Network.hs \
633         test/hs/Test/Ganeti/Objects.hs \
634         test/hs/Test/Ganeti/OpCodes.hs \
635         test/hs/Test/Ganeti/Query/Filter.hs \
636         test/hs/Test/Ganeti/Query/Language.hs \
637         test/hs/Test/Ganeti/Query/Network.hs \
638         test/hs/Test/Ganeti/Query/Query.hs \
639         test/hs/Test/Ganeti/Rpc.hs \
640         test/hs/Test/Ganeti/Runtime.hs \
641         test/hs/Test/Ganeti/Ssconf.hs \
642         test/hs/Test/Ganeti/THH.hs \
643         test/hs/Test/Ganeti/TestCommon.hs \
644         test/hs/Test/Ganeti/TestHTools.hs \
645         test/hs/Test/Ganeti/TestHelper.hs \
646         test/hs/Test/Ganeti/Types.hs \
647         test/hs/Test/Ganeti/Utils.hs
648
649 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
650
651 HS_BUILT_SRCS = \
652         test/hs/Test/Ganeti/TestImports.hs \
653         src/Ganeti/Constants.hs \
654         src/Ganeti/Curl/Internal.hs \
655         src/Ganeti/Version.hs
656 HS_BUILT_SRCS_IN = \
657         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
658         src/Ganeti/Curl/Internal.hsc
659
660 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
661
662 $(RUN_IN_TEMPDIR): | stamp-directories
663
664 doc/html/index.html: ENABLE_MANPAGES =
665 doc/man-html/index.html: ENABLE_MANPAGES = 1
666 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
667
668 # Note: we use here an order-only prerequisite, as the contents of
669 # _autoconf.py are not actually influencing the html build output: it
670 # has to exist in order for the sphinx module to be loaded
671 # successfully, but we certainly don't want the docs to be rebuilt if
672 # it changes
673 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
674         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
675         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
676         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
677         | $(BUILT_PYTHON_SOURCES)
678         @test -n "$(SPHINX)" || \
679             { echo 'sphinx-build' not found during configure; exit 1; }
680 if !MANPAGES_IN_DOC
681         if test -n '$(ENABLE_MANPAGES)'; then \
682           echo 'Man pages in documentation were disabled at configure time' >&2; \
683           exit 1; \
684         fi
685 endif
686 ## Sphinx provides little control over what content should be included. Some
687 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
688 ## build two different versions of the documentation--once without man pages and
689 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
690 ## us with this, but requires running in a temporary directory. It moves the
691 ## correct files into place depending on environment variables.
692         dir=$(dir $@) && \
693         @mkdir_p@ $$dir && \
694         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
695         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
696             -d . \
697             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
698             -D release="$(PACKAGE_VERSION)" \
699             -D graphviz_dot="$(DOT)" \
700             -D enable_manpages="$(ENABLE_MANPAGES)" \
701             doc $(CURDIR)/$$dir && \
702         rm -f $$dir/.buildinfo $$dir/objects.inv
703         touch $@
704
705 doc/html: doc/html/index.html
706
707 doc/man-html: doc/man-html/index.html
708
709 doc/install-quick.rst: INSTALL
710 doc/news.rst: NEWS
711 doc/upgrade.rst: UPGRADE
712
713 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
714         set -e; \
715         { echo '.. This file is automatically updated at build time from $<.'; \
716           echo '.. Do not edit.'; \
717           echo; \
718           cat $<; \
719         } > $@
720
721 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
722         { echo '.. This file is automatically generated, do not edit!'; \
723           echo ''; \
724           echo 'Man pages'; \
725           echo '========='; \
726           echo; \
727           echo '.. toctree::'; \
728           echo '   :maxdepth: 1'; \
729           echo; \
730           for i in $(notdir $(mandocrst)); do \
731             echo "   $$i"; \
732           done | LC_ALL=C sort; \
733         } > $@
734
735 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
736 if MANPAGES_IN_DOC
737         { echo '.. This file is automatically updated at build time from $<.'; \
738           echo '.. Do not edit.'; \
739           echo; \
740           echo "$*"; \
741           echo '=========================================='; \
742           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
743         } > $@
744 else
745         echo 'Man pages in documentation were disabled at configure time' >&2; \
746         exit 1;
747 endif
748
749 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
750         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
751
752 userspecs = \
753         doc/users/users \
754         doc/users/groups \
755         doc/users/groupmemberships
756
757 # Things to build but not to install (add it to EXTRA_DIST if it should be
758 # distributed)
759 noinst_DATA = \
760         $(BUILT_EXAMPLES) \
761         doc/examples/bash_completion \
762         doc/examples/bash_completion-debug \
763         $(userspecs) \
764         $(manhtml)
765
766 if HAS_SPHINX
767 if MANPAGES_IN_DOC
768 noinst_DATA += doc/man-html
769 else
770 noinst_DATA += doc/html
771 endif
772 endif
773
774 gnt_scripts = \
775         scripts/gnt-backup \
776         scripts/gnt-cluster \
777         scripts/gnt-debug \
778         scripts/gnt-group \
779         scripts/gnt-instance \
780         scripts/gnt-job \
781         scripts/gnt-network \
782         scripts/gnt-node \
783         scripts/gnt-os \
784         scripts/gnt-storage
785
786 PYTHON_BOOTSTRAP_SBIN = \
787         daemons/ganeti-masterd \
788         daemons/ganeti-noded \
789         daemons/ganeti-rapi \
790         daemons/ganeti-watcher \
791         $(gnt_scripts)
792
793 PYTHON_BOOTSTRAP = \
794         $(PYTHON_BOOTSTRAP_SBIN) \
795         tools/burnin \
796         tools/ensure-dirs \
797         tools/node-cleanup \
798         tools/node-daemon-setup \
799         tools/prepare-node-join
800
801 qa_scripts = \
802         qa/__init__.py \
803         qa/ganeti-qa.py \
804         qa/qa_cluster.py \
805         qa/qa_config.py \
806         qa/qa_daemon.py \
807         qa/qa_env.py \
808         qa/qa_error.py \
809         qa/qa_group.py \
810         qa/qa_instance.py \
811         qa/qa_job.py \
812         qa/qa_node.py \
813         qa/qa_os.py \
814         qa/qa_rapi.py \
815         qa/qa_tags.py \
816         qa/qa_utils.py
817
818 bin_SCRIPTS =
819 if WANT_HTOOLS
820 bin_SCRIPTS += $(HS_BIN_PROGS)
821 install-exec-hook:
822         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
823 # FIXME: this is a hardcoded logic, instead of auto-resolving
824         $(LN_S) -f ../../../bin/htools \
825           $(DESTDIR)$(iallocatorsdir)/hail
826         for role in $(HS_BIN_ROLES); do \
827           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
828         done
829 endif
830
831 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
832         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
833           echo "Error: cannot run unittests without the development" \
834                " libraries (see devnotes.rst)" 1>&2; \
835           exit 1; \
836         fi
837         @rm -f $(notdir $@).tix
838         $(GHC) --make \
839           $(HFLAGS) \
840           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
841           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
842           $(HEXTRA) $(HEXTRA_INT) $@
843         @touch "$@"
844
845 # for the test/hs/htest binary, we need to enable profiling/coverage
846 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
847
848 # we compile the hpc-htools binary with the program coverage
849 test/hs/hpc-htools: HEXTRA_INT=-fhpc
850
851 # we compile the hpc-mon-collector binary with the program coverage
852 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
853
854 # test dependency
855 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
856
857 # rules for building profiling-enabled versions of the haskell
858 # programs: hs-prof does the full two-step build, whereas
859 # hs-prof-quick does only the final rebuild (hs-prof must have been
860 # run before)
861 .PHONY: hs-prof hs-prof-quick
862 hs-prof:
863         @if [ -z "$(TARGET)" ]; then \
864           echo "You need to define TARGET when running this rule" 1>&2; \
865           exit 1; \
866         fi
867         $(MAKE) $(AM_MAKEFLAGS) clean
868         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
869         rm -f $(HS_ALL_PROGS)
870         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
871
872 hs-prof-quick:
873         @if [ -z "$(TARGET)" ]; then \
874           echo "You need to define TARGET when running this rule" 1>&2; \
875           exit 1; \
876         fi
877         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
878
879 dist_sbin_SCRIPTS = \
880         tools/ganeti-listrunner
881
882 nodist_sbin_SCRIPTS = \
883         $(PYTHON_BOOTSTRAP_SBIN) \
884         daemons/ganeti-cleaner
885
886 if ENABLE_CONFD
887 src/ganeti-confd: src/hconfd
888         cp -f $< $@
889
890 src/ganeti-luxid: src/hluxid
891         cp -f $< $@
892
893 nodist_sbin_SCRIPTS += src/ganeti-confd
894 nodist_sbin_SCRIPTS += src/ganeti-luxid
895 endif
896
897 if ENABLE_MOND
898 nodist_sbin_SCRIPTS += src/ganeti-mond
899 endif
900
901 python_scripts = \
902         tools/cfgshell \
903         tools/cfgupgrade \
904         tools/cfgupgrade12 \
905         tools/cluster-merge \
906         tools/confd-client \
907         tools/fmtjson \
908         tools/lvmstrap \
909         tools/move-instance \
910         tools/ovfconverter \
911         tools/sanitize-config
912
913 dist_tools_SCRIPTS = \
914         $(python_scripts) \
915         tools/burnin \
916         tools/kvm-console-wrapper \
917         tools/master-ip-setup \
918         tools/xen-console-wrapper
919
920 nodist_tools_python_scripts = \
921         tools/node-cleanup
922
923 nodist_tools_SCRIPTS = \
924         $(nodist_tools_python_scripts) \
925         tools/users-setup \
926         tools/vcluster-setup
927
928 pkglib_python_scripts = \
929         daemons/import-export \
930         tools/check-cert-expired
931
932 nodist_pkglib_python_scripts = \
933         tools/ensure-dirs \
934         tools/node-daemon-setup \
935         tools/prepare-node-join
936
937 myexeclib_SCRIPTS = \
938         daemons/daemon-util \
939         tools/kvm-ifup \
940         $(pkglib_python_scripts) \
941         $(HS_MYEXECLIB_PROGS)
942
943 nodist_myexeclib_SCRIPTS = \
944         $(nodist_pkglib_python_scripts)
945
946 EXTRA_DIST = \
947         NEWS \
948         UPGRADE \
949         epydoc.conf.in \
950         pylintrc \
951         autotools/build-bash-completion \
952         autotools/build-rpc \
953         autotools/check-header \
954         autotools/check-imports \
955         autotools/check-man-dashes \
956         autotools/check-man-references \
957         autotools/check-man-warnings \
958         autotools/check-news \
959         autotools/check-python-code \
960         autotools/check-tar \
961         autotools/check-version \
962         autotools/convert-constants \
963         autotools/docpp \
964         autotools/gen-py-coverage \
965         autotools/sphinx-wrapper \
966         autotools/testrunner \
967         autotools/wrong-hardcoded-paths \
968         $(RUN_IN_TEMPDIR) \
969         daemons/daemon-util.in \
970         daemons/ganeti-cleaner.in \
971         $(pkglib_python_scripts) \
972         devel/upload \
973         devel/webserver \
974         tools/kvm-ifup.in \
975         tools/vcluster-setup.in \
976         $(docinput) \
977         doc/html \
978         $(BUILT_EXAMPLES:%=%.in) \
979         doc/examples/ganeti.default \
980         doc/examples/ganeti.default-debug \
981         doc/examples/hooks/ethers \
982         doc/examples/gnt-debug/README \
983         doc/examples/gnt-debug/delay0.json \
984         doc/examples/gnt-debug/delay50.json \
985         doc/users/groupmemberships.in \
986         doc/users/groups.in \
987         doc/users/users.in \
988         test/py/lockperf.py \
989         test/py/testutils.py \
990         test/py/mocks.py \
991         $(dist_TESTS) \
992         $(TEST_FILES) \
993         man/footer.rst \
994         $(manrst) \
995         $(maninput) \
996         qa/qa-sample.json \
997         $(qa_scripts) \
998         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
999         $(HS_PROG_SRCS) \
1000         src/lint-hints.hs \
1001         test/hs/cli-tests-defs.sh \
1002         test/hs/offline-test.sh \
1003         .ghci
1004
1005 man_MANS = \
1006         man/ganeti-cleaner.8 \
1007         man/ganeti-confd.8 \
1008         man/ganeti-luxid.8 \
1009         man/ganeti-listrunner.8 \
1010         man/ganeti-masterd.8 \
1011         man/ganeti-mond.8 \
1012         man/ganeti-noded.8 \
1013         man/ganeti-os-interface.7 \
1014         man/ganeti-extstorage-interface.7 \
1015         man/ganeti-rapi.8 \
1016         man/ganeti-watcher.8 \
1017         man/ganeti.7 \
1018         man/gnt-backup.8 \
1019         man/gnt-cluster.8 \
1020         man/gnt-debug.8 \
1021         man/gnt-group.8 \
1022         man/gnt-network.8 \
1023         man/gnt-instance.8 \
1024         man/gnt-job.8 \
1025         man/gnt-node.8 \
1026         man/gnt-os.8 \
1027         man/gnt-storage.8 \
1028         man/hail.1 \
1029         man/harep.1 \
1030         man/hbal.1 \
1031         man/hcheck.1 \
1032         man/hinfo.1 \
1033         man/hscan.1 \
1034         man/hspace.1 \
1035         man/hroller.1 \
1036         man/htools.1 \
1037         man/mon-collector.7
1038
1039 # Remove extensions from all filenames in man_MANS
1040 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1041
1042 manrst = $(patsubst %,%.rst,$(mannoext))
1043 manhtml = $(patsubst %.rst,%.html,$(manrst))
1044 mangen = $(patsubst %.rst,%.gen,$(manrst))
1045 maninput = \
1046         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1047         $(patsubst %.html,%.html.in,$(manhtml)) \
1048         $(mangen)
1049
1050 TEST_FILES = \
1051         test/autotools/autotools-check-news.test \
1052         test/data/htools/clean-nonzero-score.data \
1053         test/data/htools/common-suffix.data \
1054         test/data/htools/empty-cluster.data \
1055         test/data/htools/hail-alloc-drbd.json \
1056         test/data/htools/hail-alloc-invalid-network.json \
1057         test/data/htools/hail-alloc-invalid-twodisks.json \
1058         test/data/htools/hail-alloc-restricted-network.json \
1059         test/data/htools/hail-alloc-twodisks.json \
1060         test/data/htools/hail-change-group.json \
1061         test/data/htools/hail-invalid-reloc.json \
1062         test/data/htools/hail-node-evac.json \
1063         test/data/htools/hail-reloc-drbd.json \
1064         test/data/htools/hbal-excl-tags.data \
1065         test/data/htools/hbal-split-insts.data \
1066         test/data/htools/hspace-tiered-dualspec.data \
1067         test/data/htools/hspace-tiered-ipolicy.data \
1068         test/data/htools/hspace-tiered-resourcetypes.data \
1069         test/data/htools/hspace-tiered.data \
1070         test/data/htools/invalid-node.data \
1071         test/data/htools/missing-resources.data \
1072         test/data/htools/multiple-master.data \
1073         test/data/htools/n1-failure.data \
1074         test/data/htools/rapi/groups.json \
1075         test/data/htools/rapi/info.json \
1076         test/data/htools/rapi/instances.json \
1077         test/data/htools/rapi/nodes.json \
1078         test/data/htools/unique-reboot-order.data \
1079         test/hs/shelltests/htools-balancing.test \
1080         test/hs/shelltests/htools-basic.test \
1081         test/hs/shelltests/htools-dynutil.test \
1082         test/hs/shelltests/htools-excl.test \
1083         test/hs/shelltests/htools-hail.test \
1084         test/hs/shelltests/htools-hroller.test \
1085         test/hs/shelltests/htools-hspace.test \
1086         test/hs/shelltests/htools-invalid.test \
1087         test/hs/shelltests/htools-multi-group.test \
1088         test/hs/shelltests/htools-no-backend.test \
1089         test/hs/shelltests/htools-rapi.test \
1090         test/hs/shelltests/htools-single-group.test \
1091         test/hs/shelltests/htools-text-backend.test \
1092         test/hs/shelltests/htools-mon-collector.test \
1093         test/data/bdev-drbd-8.0.txt \
1094         test/data/bdev-drbd-8.3.txt \
1095         test/data/bdev-drbd-disk.txt \
1096         test/data/bdev-drbd-net-ip4.txt \
1097         test/data/bdev-drbd-net-ip6.txt \
1098         test/data/bdev-rbd/json_output_empty.txt \
1099         test/data/bdev-rbd/json_output_extra_matches.txt \
1100         test/data/bdev-rbd/json_output_no_matches.txt \
1101         test/data/bdev-rbd/json_output_ok.txt \
1102         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1103         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1104         test/data/bdev-rbd/plain_output_new_ok.txt \
1105         test/data/bdev-rbd/plain_output_old_empty.txt \
1106         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1107         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1108         test/data/bdev-rbd/plain_output_old_ok.txt \
1109         test/data/bdev-rbd/output_invalid.txt \
1110         test/data/cert1.pem \
1111         test/data/cert2.pem \
1112         test/data/cluster_config_2.7.json \
1113         test/data/cluster_config_downgraded_2.7.json \
1114         test/data/instance-minor-pairing.txt \
1115         test/data/ip-addr-show-dummy0.txt \
1116         test/data/ip-addr-show-lo-ipv4.txt \
1117         test/data/ip-addr-show-lo-ipv6.txt \
1118         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1119         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1120         test/data/ip-addr-show-lo-oneline.txt \
1121         test/data/ip-addr-show-lo.txt \
1122         test/data/kvm_0.12.5_help.txt \
1123         test/data/kvm_0.15.90_help.txt \
1124         test/data/kvm_0.9.1_help.txt \
1125         test/data/kvm_0.9.1_help_boot_test.txt \
1126         test/data/kvm_1.0_help.txt \
1127         test/data/kvm_1.1.2_help.txt \
1128         test/data/NEWS_OK.txt \
1129         test/data/NEWS_previous_unreleased.txt \
1130         test/data/ovfdata/compr_disk.vmdk.gz \
1131         test/data/ovfdata/config.ini \
1132         test/data/ovfdata/corrupted_resources.ovf \
1133         test/data/ovfdata/empty.ini \
1134         test/data/ovfdata/empty.ovf \
1135         test/data/ovfdata/ganeti.mf \
1136         test/data/ovfdata/ganeti.ovf \
1137         test/data/ovfdata/gzip_disk.ovf \
1138         test/data/ovfdata/new_disk.vmdk \
1139         test/data/ovfdata/no_disk.ini \
1140         test/data/ovfdata/no_disk_in_ref.ovf \
1141         test/data/ovfdata/no_os.ini \
1142         test/data/ovfdata/no_ovf.ova \
1143         test/data/ovfdata/other/rawdisk.raw \
1144         test/data/ovfdata/ova.ova \
1145         test/data/ovfdata/rawdisk.raw \
1146         test/data/ovfdata/second_disk.vmdk \
1147         test/data/ovfdata/unsafe_path.ini \
1148         test/data/ovfdata/virtualbox.ovf \
1149         test/data/ovfdata/wrong_config.ini \
1150         test/data/ovfdata/wrong_extension.ovd \
1151         test/data/ovfdata/wrong_manifest.mf \
1152         test/data/ovfdata/wrong_manifest.ovf \
1153         test/data/ovfdata/wrong_ova.ova \
1154         test/data/ovfdata/wrong_xml.ovf \
1155         test/data/proc_drbd8.txt \
1156         test/data/proc_drbd80-emptyline.txt \
1157         test/data/proc_drbd83.txt \
1158         test/data/proc_drbd83_sync.txt \
1159         test/data/proc_drbd83_sync_want.txt \
1160         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1161         test/data/proc_meminfo.txt \
1162         test/data/proc_cpuinfo.txt \
1163         test/data/qa-minimal-nodes-instances-only.json \
1164         test/data/sys_drbd_usermode_helper.txt \
1165         test/data/vgreduce-removemissing-2.02.02.txt \
1166         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1167         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1168         test/data/vgs-missing-pvs-2.02.02.txt \
1169         test/data/vgs-missing-pvs-2.02.66.txt \
1170         test/data/xen-xm-info-4.0.1.txt \
1171         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1172         test/data/xen-xm-list-4.0.1-four-instances.txt \
1173         test/data/xen-xm-list-long-4.0.1.txt \
1174         test/data/xen-xm-uptime-4.0.1.txt \
1175         test/py/ganeti-cli.test \
1176         test/py/gnt-cli.test \
1177         test/py/import-export_unittest-helper
1178
1179
1180 python_tests = \
1181         doc/examples/rapi_testutils.py \
1182         test/py/cfgupgrade_unittest.py \
1183         test/py/docs_unittest.py \
1184         test/py/ganeti.asyncnotifier_unittest.py \
1185         test/py/ganeti.backend_unittest-runasroot.py \
1186         test/py/ganeti.backend_unittest.py \
1187         test/py/ganeti.bdev_unittest.py \
1188         test/py/ganeti.cli_unittest.py \
1189         test/py/ganeti.client.gnt_cluster_unittest.py \
1190         test/py/ganeti.client.gnt_instance_unittest.py \
1191         test/py/ganeti.client.gnt_job_unittest.py \
1192         test/py/ganeti.cmdlib_unittest.py \
1193         test/py/ganeti.compat_unittest.py \
1194         test/py/ganeti.confd.client_unittest.py \
1195         test/py/ganeti.config_unittest.py \
1196         test/py/ganeti.constants_unittest.py \
1197         test/py/ganeti.daemon_unittest.py \
1198         test/py/ganeti.errors_unittest.py \
1199         test/py/ganeti.hooks_unittest.py \
1200         test/py/ganeti.ht_unittest.py \
1201         test/py/ganeti.http_unittest.py \
1202         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1203         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1204         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1205         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1206         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1207         test/py/ganeti.hypervisor_unittest.py \
1208         test/py/ganeti.impexpd_unittest.py \
1209         test/py/ganeti.jqueue_unittest.py \
1210         test/py/ganeti.jstore_unittest.py \
1211         test/py/ganeti.locking_unittest.py \
1212         test/py/ganeti.luxi_unittest.py \
1213         test/py/ganeti.masterd.iallocator_unittest.py \
1214         test/py/ganeti.masterd.instance_unittest.py \
1215         test/py/ganeti.mcpu_unittest.py \
1216         test/py/ganeti.netutils_unittest.py \
1217         test/py/ganeti.objects_unittest.py \
1218         test/py/ganeti.opcodes_unittest.py \
1219         test/py/ganeti.outils_unittest.py \
1220         test/py/ganeti.ovf_unittest.py \
1221         test/py/ganeti.qlang_unittest.py \
1222         test/py/ganeti.query_unittest.py \
1223         test/py/ganeti.rapi.baserlib_unittest.py \
1224         test/py/ganeti.rapi.client_unittest.py \
1225         test/py/ganeti.rapi.resources_unittest.py \
1226         test/py/ganeti.rapi.rlib2_unittest.py \
1227         test/py/ganeti.rapi.testutils_unittest.py \
1228         test/py/ganeti.rpc_unittest.py \
1229         test/py/ganeti.runtime_unittest.py \
1230         test/py/ganeti.serializer_unittest.py \
1231         test/py/ganeti.server.rapi_unittest.py \
1232         test/py/ganeti.ssconf_unittest.py \
1233         test/py/ganeti.ssh_unittest.py \
1234         test/py/ganeti.storage_unittest.py \
1235         test/py/ganeti.tools.burnin_unittest.py \
1236         test/py/ganeti.tools.ensure_dirs_unittest.py \
1237         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1238         test/py/ganeti.tools.prepare_node_join_unittest.py \
1239         test/py/ganeti.uidpool_unittest.py \
1240         test/py/ganeti.utils.algo_unittest.py \
1241         test/py/ganeti.utils.filelock_unittest.py \
1242         test/py/ganeti.utils.hash_unittest.py \
1243         test/py/ganeti.utils.io_unittest-runasroot.py \
1244         test/py/ganeti.utils.io_unittest.py \
1245         test/py/ganeti.utils.log_unittest.py \
1246         test/py/ganeti.utils.lvm_unittest.py \
1247         test/py/ganeti.utils.mlock_unittest.py \
1248         test/py/ganeti.utils.nodesetup_unittest.py \
1249         test/py/ganeti.utils.process_unittest.py \
1250         test/py/ganeti.utils.retry_unittest.py \
1251         test/py/ganeti.utils.text_unittest.py \
1252         test/py/ganeti.utils.wrapper_unittest.py \
1253         test/py/ganeti.utils.x509_unittest.py \
1254         test/py/ganeti.utils_unittest.py \
1255         test/py/ganeti.vcluster_unittest.py \
1256         test/py/ganeti.workerpool_unittest.py \
1257         test/py/pycurl_reset_unittest.py \
1258         test/py/qa.qa_config_unittest.py \
1259         test/py/tempfile_fork_unittest.py
1260
1261 haskell_tests = test/hs/htest
1262
1263 dist_TESTS = \
1264         test/py/check-cert-expired_unittest.bash \
1265         test/py/daemon-util_unittest.bash \
1266         test/py/ganeti-cleaner_unittest.bash \
1267         test/py/import-export_unittest.bash \
1268         test/py/cli-test.bash \
1269         test/py/bash_completion.bash
1270
1271 if PY_UNIT
1272 dist_TESTS += $(python_tests)
1273 endif
1274
1275 nodist_TESTS =
1276 check_SCRIPTS =
1277
1278 if WANT_HSTESTS
1279 nodist_TESTS += $(haskell_tests)
1280 dist_TESTS += test/hs/offline-test.sh
1281 check_SCRIPTS += \
1282         test/hs/hpc-htools \
1283         test/hs/hpc-mon-collector \
1284         $(HS_BUILT_TEST_HELPERS)
1285 endif
1286
1287 TESTS = $(dist_TESTS) $(nodist_TESTS)
1288
1289 # Environment for all tests
1290 PLAIN_TESTS_ENVIRONMENT = \
1291         PYTHONPATH=. \
1292         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1293         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1294         $(RUN_IN_TEMPDIR)
1295
1296 # Environment for tests run by automake
1297 TESTS_ENVIRONMENT = \
1298         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1299
1300 all_python_code = \
1301         $(dist_sbin_SCRIPTS) \
1302         $(python_scripts) \
1303         $(pkglib_python_scripts) \
1304         $(nodist_pkglib_python_scripts) \
1305         $(nodist_tools_python_scripts) \
1306         $(pkgpython_PYTHON) \
1307         $(client_PYTHON) \
1308         $(cmdlib_PYTHON) \
1309         $(hypervisor_PYTHON) \
1310         $(rapi_PYTHON) \
1311         $(server_PYTHON) \
1312         $(pytools_PYTHON) \
1313         $(http_PYTHON) \
1314         $(confd_PYTHON) \
1315         $(masterd_PYTHON) \
1316         $(impexpd_PYTHON) \
1317         $(utils_PYTHON) \
1318         $(watcher_PYTHON) \
1319         $(noinst_PYTHON) \
1320         $(qa_scripts)
1321
1322 if PY_UNIT
1323 all_python_code += $(python_tests)
1324 endif
1325
1326 srclink_files = \
1327         man/footer.rst \
1328         test/py/check-cert-expired_unittest.bash \
1329         test/py/daemon-util_unittest.bash \
1330         test/py/ganeti-cleaner_unittest.bash \
1331         test/py/import-export_unittest.bash \
1332         test/py/cli-test.bash \
1333         test/py/bash_completion.bash \
1334         test/hs/offline-test.sh \
1335         test/hs/cli-tests-defs.sh \
1336         $(all_python_code) \
1337         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1338         $(docinput)
1339
1340 check_python_code = \
1341         $(BUILD_BASH_COMPLETION) \
1342         $(CHECK_IMPORTS) \
1343         $(CHECK_HEADER) \
1344         $(DOCPP) \
1345         $(all_python_code)
1346
1347 lint_python_code = \
1348         ganeti \
1349         ganeti/http/server.py \
1350         $(dist_sbin_SCRIPTS) \
1351         $(python_scripts) \
1352         $(pkglib_python_scripts) \
1353         $(BUILD_BASH_COMPLETION) \
1354         $(CHECK_IMPORTS) \
1355         $(CHECK_HEADER) \
1356         $(DOCPP) \
1357         $(PYTHON_BOOTSTRAP)
1358
1359 standalone_python_modules = \
1360         lib/rapi/client.py \
1361         tools/ganeti-listrunner
1362
1363 pep8_python_code = \
1364         ganeti \
1365         ganeti/http/server.py \
1366         $(dist_sbin_SCRIPTS) \
1367         $(python_scripts) \
1368         $(pkglib_python_scripts) \
1369         $(BUILD_BASH_COMPLETION) \
1370         $(CHECK_HEADER) \
1371         $(DOCPP) \
1372         $(PYTHON_BOOTSTRAP) \
1373         qa
1374
1375 test/py/daemon-util_unittest.bash: daemons/daemon-util
1376
1377 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1378
1379 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1380
1381 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1382         sed -f $(REPLACE_VARS_SED) < $< > $@
1383         chmod +x $@
1384
1385 tools/users-setup: Makefile $(userspecs)
1386         set -e; \
1387         { echo '#!/bin/sh'; \
1388           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1389           echo 'then echo "This will do the following changes"'; \
1390           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1391                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1392           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1393                                   else {print "echo + Will add user",$$1}; count++}\
1394                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1395           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1396           echo 'echo'; \
1397           echo 'echo "OK? (y/n)"'; \
1398           echo 'read confirm'; \
1399           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1400           echo 'fi'; \
1401           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1402           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1403           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1404         } > $@
1405         chmod +x $@
1406
1407 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1408         sed -f $(REPLACE_VARS_SED) < $< > $@
1409         chmod +x $@
1410
1411 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1412         sed -f $(REPLACE_VARS_SED) < $< > $@
1413         chmod +x $@
1414
1415 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1416         sed -f $(REPLACE_VARS_SED) < $< > $@
1417
1418 doc/examples/bash_completion: BC_ARGS = --compact
1419 doc/examples/bash_completion-debug: BC_ARGS =
1420
1421 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1422         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1423         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1424         daemons/ganeti-cleaner \
1425         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1426         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1427           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1428
1429 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1430         lib/build/shell_example_lexer.py \
1431         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1432         @echo "Checking $< for hardcoded paths..."
1433         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1434           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1435           exit 1; \
1436         fi
1437         set -e ; \
1438         trap 'echo auto-removing $@; rm $@' EXIT; \
1439         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1440         $(CHECK_MAN_REFERENCES) $@; \
1441         trap - EXIT
1442
1443 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1444         @test -n "$(PANDOC)" || \
1445           { echo 'pandoc' not found during configure; exit 1; }
1446         set -o pipefail -e; \
1447         trap 'echo auto-removing $@; rm $@' EXIT; \
1448         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1449           sed -e 's/\\@/@/g' > $@; \
1450         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1451         $(CHECK_MAN_DASHES) $@; \
1452         trap - EXIT
1453
1454 man/%.html.in: man/%.gen man/footer.rst
1455         @test -n "$(PANDOC)" || \
1456           { echo 'pandoc' not found during configure; exit 1; }
1457         set -o pipefail ; \
1458         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1459           sed -e 's/\\@/@/g' > $@
1460
1461 man/%: man/%.in  $(REPLACE_VARS_SED)
1462         sed -f $(REPLACE_VARS_SED) < $< > $@
1463
1464 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1465         sed -f $(REPLACE_VARS_SED) < $< > $@
1466
1467 vcs-version:
1468         if test -d .git; then \
1469           git describe > $@; \
1470         elif test ! -f $@ ; then \
1471           echo "Cannot auto-generate $@ file"; exit 1; \
1472         fi
1473
1474 .PHONY: clean-vcs-version
1475 clean-vcs-version:
1476         rm -f vcs-version
1477
1478 .PHONY: regen-vcs-version
1479 regen-vcs-version:
1480         @set -e; \
1481         cd $(srcdir); \
1482         if test -d .git; then \
1483           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1484           git describe > $$T; \
1485           if ! cmp --quiet $$T vcs-version; then \
1486             mv $$T vcs-version; \
1487           fi; \
1488         fi
1489
1490 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1491         vcs-version $(built_base_sources)
1492         set -e; \
1493         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1494         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1495
1496 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1497         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1498         lib/jstore.py $(RUN_IN_TEMPDIR) \
1499         $(CONVERT_CONSTANTS) $(built_base_sources) \
1500         | lib/_vcsversion.py
1501         set -e; \
1502         { cat $< ; \
1503           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1504         } > $@
1505
1506 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1507         hsc2hs -o $@ $<
1508
1509 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1510         $(built_base_sources)
1511         set -e; \
1512         { cat $< ; \
1513           echo ; \
1514           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1515             echo "import $$name ()" ; \
1516           done ; \
1517         } > $@
1518
1519 lib/_autoconf.py: Makefile | stamp-directories
1520         set -e; \
1521         { echo '# This file is automatically generated, do not edit!'; \
1522           echo '#'; \
1523           echo ''; \
1524           echo '"""Build-time configuration for Ganeti.'; \
1525           echo '';\
1526           echo 'This file is autogenerated by the build process.'; \
1527           echo 'For any changes you need to re-run ./configure (and'; \
1528           echo 'not edit by hand).'; \
1529           echo ''; \
1530           echo '"""'; \
1531           echo ''; \
1532           echo '# pylint: disable=C0301,C0324'; \
1533           echo '# because this is autogenerated, we do not want'; \
1534           echo '# style warnings' ; \
1535           echo ''; \
1536           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1537           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1538           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1539           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1540           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1541           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1542           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1543           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1544           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1545           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1546           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1547           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1548           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1549           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1550           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1551           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1552           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1553           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1554           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1555           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1556           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1557           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1558           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1559           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1560           echo "KVM_PATH = '$(KVM_PATH)'"; \
1561           echo "IP_PATH = '$(IP_PATH)'"; \
1562           echo "SOCAT_PATH = '$(SOCAT)'"; \
1563           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1564           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1565           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1566           echo "TOOLSDIR = '$(toolsdir)'"; \
1567           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1568           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1569           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1570           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1571           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1572           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1573           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1574           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1575           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1576           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1577           echo "RAPI_USER = '$(RAPI_USER)'"; \
1578           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1579           echo "CONFD_USER = '$(CONFD_USER)'"; \
1580           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1581           echo "LUXID_USER = '$(LUXID_USER)'"; \
1582           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1583           echo "NODED_USER = '$(NODED_USER)'"; \
1584           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1585           echo "MOND_USER = '$(MOND_USER)'"; \
1586           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1587           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1588           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1589           echo "HTOOLS = True"; \
1590           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1591           echo "XEN_CMD = '$(XEN_CMD)'"; \
1592           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1593           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1594           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1595 ## Write dictionary with man page name as the key and the section number as the
1596 ## value
1597           echo "MAN_PAGES = {"; \
1598           for i in $(notdir $(man_MANS)); do \
1599             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1600           done; \
1601           echo "}"; \
1602         } > $@
1603
1604 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1605         set -e; \
1606         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1607         { echo '# This file is automatically generated, do not edit!'; \
1608           echo '#'; \
1609           echo ''; \
1610           echo '"""Build-time VCS version number for Ganeti.'; \
1611           echo '';\
1612           echo 'This file is autogenerated by the build process.'; \
1613           echo 'For any changes you need to re-run ./configure (and'; \
1614           echo 'not edit by hand).'; \
1615           echo ''; \
1616           echo '"""'; \
1617           echo ''; \
1618           echo '# pylint: disable=C0301,C0324'; \
1619           echo '# because this is autogenerated, we do not want'; \
1620           echo '# style warnings' ; \
1621           echo ''; \
1622           echo "VCS_VERSION = '$$VCSVER'"; \
1623         } > $@
1624
1625 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1626         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1627
1628 $(SHELL_ENV_INIT): Makefile stamp-directories
1629         set -e; \
1630         { echo '# Allow overriding for tests'; \
1631           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1632           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1633           echo; \
1634           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1635           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1636           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1637           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1638           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1639         } > $@
1640
1641 ## Writes sed script to replace placeholders with build-time values. The
1642 ## additional quotes after the first @ sign are necessary to stop configure
1643 ## from replacing those values as well.
1644 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1645         set -e; \
1646         { echo 's#@''PREFIX@#$(prefix)#g'; \
1647           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1648           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1649           echo 's#@''BINDIR@#$(bindir)#g'; \
1650           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1651           echo 's#@''LIBDIR@#$(libdir)#g'; \
1652           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1653           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1654           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1655           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1656           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1657           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1658           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1659           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1660           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1661           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1662           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1663           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1664           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1665           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1666           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1667           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1668           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1669           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1670           echo 's#@''GNTNODEDGROUP@#$(NODED_GROUP)#g'; \
1671           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1672           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1673           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1674           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1675           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1676           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1677           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1678           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1679           echo; \
1680           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1681           echo '  r $(SHELL_ENV_INIT)'; \
1682           echo '  d'; \
1683           echo '}'; \
1684         } > $@
1685
1686 # Using deferred evaluation
1687 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1688 daemons/ganeti-watcher: MODULE = ganeti.watcher
1689 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1690 tools/burnin: MODULE = ganeti.tools.burnin
1691 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1692 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1693 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1694 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1695 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1696
1697 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1698         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1699         set -e; \
1700         { echo '#!/usr/bin/python'; \
1701           echo '# This file is automatically generated, do not edit!'; \
1702           echo "# Edit $(MODULE) instead."; \
1703           echo; \
1704           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1705           echo; \
1706           echo '# pylint: disable=C0103'; \
1707           echo '# C0103: Invalid name'; \
1708           echo; \
1709           echo 'import sys'; \
1710           echo 'import $(MODULE) as main'; \
1711           echo; \
1712           echo '# Temporarily alias commands until bash completion'; \
1713           echo '# generator is changed'; \
1714           echo 'if hasattr(main, "commands"):'; \
1715           echo '  commands = main.commands # pylint: disable=E1101'; \
1716           echo 'if hasattr(main, "aliases"):'; \
1717           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1718           echo; \
1719           echo 'if __name__ == "__main__":'; \
1720           echo '  sys.exit(main.Main())'; \
1721         } > $@
1722         chmod u+x $@
1723
1724 $(HS_BUILT_TEST_HELPERS): Makefile
1725         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1726         set -e; \
1727         { echo '#!/bin/sh'; \
1728           echo '# This file is automatically generated, do not edit!'; \
1729           echo "# Edit Makefile.am instead."; \
1730           echo; \
1731           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1732         } > $@
1733         chmod u+x $@
1734
1735 stamp-directories: Makefile
1736         $(MAKE) $(AM_MAKEFLAGS) ganeti
1737         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1738         touch $@
1739
1740 # We need to create symlinks because "make distcheck" will not install Python
1741 # files when building.
1742 stamp-srclinks: Makefile | stamp-directories
1743         set -e; \
1744         for i in $(srclink_files); do \
1745           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1746             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1747           fi; \
1748         done
1749         touch $@
1750
1751 .PHONY: ganeti
1752 ganeti:
1753         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1754
1755 .PHONY: check-dirs
1756 check-dirs: $(GENERATED_FILES)
1757         @set -e; \
1758         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1759           error=; \
1760           while read dir; do \
1761             case "$$dir" in \
1762               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1763               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1764             esac; \
1765           done; \
1766           for dir in $(DIRS); do \
1767             if ! test -d "$$dir"; then \
1768               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1769               error=1; \
1770             fi \
1771           done; \
1772           test -z "$$error"; \
1773         }
1774
1775 .PHONY: check-local
1776 check-local: check-dirs $(GENERATED_FILES)
1777         $(CHECK_PYTHON_CODE) $(check_python_code)
1778         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1779         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1780         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1781         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1782         error= ; \
1783         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1784           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1785           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1786             echo "Incorrect version in README, expected $$expver" >&2; \
1787             error=1; \
1788           fi; \
1789           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1790               doc/security.rst; do \
1791             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1792               "Documents Ganeti version $$expver"; then \
1793               echo "Incorrect version in $$file, expected $$expver" >&2; \
1794               error=1; \
1795             fi; \
1796           done; \
1797           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1798             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1799             error=1; \
1800           fi; \
1801           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1802             ".. Last updated for Ganeti $$expver"; then \
1803             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1804             error=1; \
1805           fi; \
1806         fi; \
1807         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1808           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1809             echo "Longest line in $$file is longer than 80 characters" >&2; \
1810             error=1; \
1811           fi; \
1812         done; \
1813         test -z "$$error"
1814
1815 .PHONY: hs-tests
1816 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1817         @rm -f htest.tix
1818         ./test/hs/htest
1819
1820 .PHONY: hs-shell
1821 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1822         @rm -f hpc-htools.tix hpc-mon-collector.tix
1823         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1824
1825 .PHONY: hs-check
1826 hs-check: hs-tests hs-shell
1827
1828 # E111: indentation is not a multiple of four
1829 # E121: continuation line indentation is not a multiple of four
1830 #       (since our indent level is not 4)
1831 # E125: continuation line does not distinguish itself from next logical line
1832 #       (since our indent level is not 4)
1833 # E127: continuation line over-indented for visual indent
1834 #       (since our indent level is not 4)
1835 # note: do NOT add E128 here; it's a valid style error in most cases!
1836 # I've seen real errors, but also some cases were we indent wrongly
1837 # due to line length; try to rework the cases where it is triggered,
1838 # instead of silencing it
1839 # E261: at least two spaces before inline comment
1840 # E501: line too long (80 characters)
1841 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1842
1843 # For excluding pep8 expects filenames only, not whole paths
1844 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1845
1846 LINT_TARGETS = pylint pylint-qa
1847 if HAS_PEP8
1848 LINT_TARGETS += pep8
1849 endif
1850 if HAS_HLINT
1851 LINT_TARGETS += hlint
1852 endif
1853
1854 .PHONY: lint
1855 lint: $(LINT_TARGETS)
1856
1857 .PHONY: pylint
1858 pylint: $(GENERATED_FILES)
1859         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1860         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1861
1862 .PHONY: pylint-qa
1863 pylint-qa: $(GENERATED_FILES)
1864         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1865         cd $(top_srcdir)/qa && \
1866           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1867           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1868
1869 .PHONY: pep8
1870 pep8: $(GENERATED_FILES)
1871         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1872         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1873           --repeat $(pep8_python_code)
1874
1875 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1876 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1877 .PHONY: hlint
1878 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1879         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1880         @rm -f doc/hs-lint.html
1881         if tty -s; then C="-c"; else C=""; fi; \
1882         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1883           --ignore "Use first" \
1884           --ignore "Use &&&" \
1885           --ignore "Use void" \
1886           --ignore "Reduce duplication" \
1887           --hint src/lint-hints \
1888           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1889         @if [ ! -f doc/hs-lint.html ]; then \
1890           echo "All good" > doc/hs-lint.html; \
1891         fi
1892
1893 # a dist hook rule for updating the vcs-version file; this is
1894 # hardcoded due to where it needs to build the file...
1895 dist-hook:
1896         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1897         rm -f $(top_distdir)/vcs-version
1898         cp -p $(srcdir)/vcs-version $(top_distdir)
1899
1900 # a distcheck hook rule for catching revision control directories
1901 distcheck-hook:
1902         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1903           echo "Found revision control files in final archive." 1>&2; \
1904           exit 1; \
1905         fi
1906         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1907           echo "Found Python byte code in final archive." 1>&2; \
1908           exit 1; \
1909         fi
1910         if find $(top_distdir) -name '*~' | grep .; then \
1911           echo "Found backup files in final archive." 1>&2; \
1912           exit 1; \
1913         fi
1914 # Empty files or directories should not be distributed. They can cause
1915 # unnecessary warnings for packagers. Directories used by automake during
1916 # distcheck must be excluded.
1917         if find $(top_distdir) -empty -and -not \( \
1918             -path $(top_distdir)/_build -or \
1919             -path $(top_distdir)/_inst \) | grep .; then \
1920           echo "Found empty files or directories in final archive." 1>&2; \
1921           exit 1; \
1922         fi
1923         if test -e $(top_distdir)/doc/man-html; then \
1924           echo "Found documentation including man pages in final archive" >&2; \
1925           exit 1; \
1926         fi
1927
1928 # Backwards compatible distcheck-release target
1929 distcheck-release: distcheck
1930
1931 distrebuildcheck: dist
1932         set -e; \
1933         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1934         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1935         cd $$builddir; \
1936         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1937         cd $(distdir); \
1938         ./configure; \
1939         $(MAKE) maintainer-clean; \
1940         cp $(abs_srcdir)/vcs-version .; \
1941         ./configure; \
1942         $(MAKE) $(AM_MAKEFLAGS)
1943
1944 dist-release: dist
1945         set -e; \
1946         for i in $(DIST_ARCHIVES); do \
1947           echo -n "Checking $$i ... "; \
1948           autotools/check-tar < $$i; \
1949           echo OK; \
1950         done
1951
1952 install-exec-local:
1953         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1954           "$(DESTDIR)${localstatedir}/log/ganeti" \
1955           "$(DESTDIR)${localstatedir}/run/ganeti"
1956
1957 .PHONY: apidoc
1958 if WANT_HSAPIDOC
1959 apidoc: py-apidoc hs-apidoc
1960 else
1961 apidoc: py-apidoc
1962 endif
1963
1964 .PHONY: py-apidoc
1965 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1966         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1967         $(RUN_IN_TEMPDIR) epydoc -v \
1968           --conf $(CURDIR)/epydoc.conf \
1969           --output $(CURDIR)/$(APIDOC_PY_DIR)
1970
1971 .PHONY: hs-apidoc
1972 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1973
1974 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1975         @test -n "$(HSCOLOUR)" || \
1976             { echo 'HsColour' not found during configure; exit 1; }
1977         @test -n "$(HADDOCK)" || \
1978             { echo 'haddock' not found during configure; exit 1; }
1979         rm -rf $(APIDOC_HS_DIR)/*
1980         for i in $(ALL_APIDOC_HS_DIRS); do \
1981           @mkdir_p@ $$i; \
1982           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1983         done
1984         set -e ; \
1985         export LC_ALL=en_US.UTF-8; \
1986         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1987         if [ "$(HS_PARALLEL3)" ]; \
1988         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1989         fi; \
1990         if [ "$(HS_REGEX_PCRE)" ]; \
1991         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1992         fi; \
1993         for file in $(HS_LIBTESTBUILT_SRCS); do \
1994           f_nosrc=$${file##src/}; \
1995           f_notst=$${f_nosrc##test/hs/}; \
1996           f_html=$${f_notst%%.hs}.html; \
1997           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1998         done ; \
1999         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2000           -t ganeti -p src/haddock-prologue \
2001           --source-module="%{MODULE/.//}.html" \
2002           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2003           $$OPTGHC \
2004           $(HS_LIBTESTBUILT_SRCS)
2005
2006 .PHONY: TAGS
2007 TAGS: $(GENERATED_FILES)
2008         rm -f TAGS
2009         $(GHC) -e ":etags" -v0 \
2010           $(filter-out -O -Werror,$(HFLAGS)) \
2011           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2012           $(HS_LIBTEST_SRCS)
2013         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2014           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2015           -path './qa/*.py' | \
2016           etags -l python -a -
2017
2018 .PHONY: coverage
2019
2020 COVERAGE_TESTS=
2021 if WANT_HTOOLS
2022 COVERAGE_TESTS += hs-coverage
2023 endif
2024 if PY_UNIT
2025 COVERAGE_TESTS += py-coverage
2026 endif
2027
2028 coverage: $(COVERAGE_TESTS)
2029
2030 .PHONY: py-coverage
2031 py-coverage: $(GENERATED_FILES) $(python_tests)
2032         @test -n "$(PYCOVERAGE)" || \
2033             { echo 'python-coverage' not found during configure; exit 1; }
2034         set -e; \
2035         COVERAGE=$(PYCOVERAGE) \
2036         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2037         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2038         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2039         $(PLAIN_TESTS_ENVIRONMENT) \
2040         $(abs_top_srcdir)/autotools/gen-py-coverage \
2041         $(python_tests)
2042
2043 .PHONY: hs-coverage
2044 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2045         rm -f *.tix
2046         $(MAKE) $(AM_MAKEFLAGS) hs-check
2047         @mkdir_p@ $(COVERAGE_HS_DIR)
2048         hpc sum --union $(HPCEXCL) \
2049           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2050         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2051         hpc report coverage-hs.tix
2052         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2053
2054 # Special "kind-of-QA" target for htools, needs special setup (all
2055 # tools compiled with -fhpc)
2056 .PHONY: live-test
2057 live-test: all
2058         set -e ; \
2059         cd src; \
2060         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2061         rm -f *.tix *.mix; \
2062         ./live-test.sh; \
2063         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2064           --output=live-test.tix ; \
2065         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2066         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2067           --srcdir=.. $(HPCEXCL) ; \
2068         hpc report --srcdir=.. live-test $(HPCEXCL)
2069
2070 commit-check: autotools-check distcheck lint apidoc
2071
2072 autotools-check:
2073         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2074   $(abs_top_srcdir)/test/autotools/*-*.test \
2075   -- --hide-successes
2076
2077 .PHONY: gitignore-check
2078 gitignore-check:
2079         @if [ -n "`git status --short`" ]; then \
2080           echo "Git status is not clean!" 1>&2 ; \
2081           git status --short; \
2082           exit 1; \
2083         fi
2084
2085 # target to rebuild all man pages (both groff and html output)
2086 .PHONY: man
2087 man: $(man_MANS) $(manhtml)
2088
2089 # Target that builds all binaries (including those that are not
2090 # rebuilt except when running the tests)
2091 .PHONY: really-all
2092 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2093
2094 # we don't need the ancient implicit rules:
2095 %: %,v
2096 %: RCS/%,v
2097 %: RCS/%
2098 %: s.%
2099 %: SCCS/s.%
2100
2101 -include ./Makefile.local
2102
2103 # vim: set noet :